package proxy

import (
	"net/http/httputil"
	"sync"
)

type bufferPool struct {
	pool *sync.Pool
}

func NewBufferPool() httputil.BufferPool {
	return &bufferPool{
		pool: new(sync.Pool),
	}
}

func (b *bufferPool) Get() []byte {
	buf := b.pool.Get()
	if buf == nil {
		return make([]byte, 8192)
	}
	return *buf.(*[]byte)
}

func (b *bufferPool) Put(buf []byte) {
	b.pool.Put(&buf)
}
